﻿using System.Linq;
using System.Web.Mvc;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.MvcEdition;

namespace DragableMarker.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            Map map = new Map("Map1",
                new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage),
                new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage));

            map.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
            map.CurrentExtent = new RectangleShape(-125, 72, 50, -46);
            map.MapUnit = GeographyUnit.DecimalDegree;

            map.CustomOverlays.Add(new WorldMapKitWmsWebOverlay());

            SimpleMarkerOverlay markerOverlay = new SimpleMarkerOverlay("MarkerOverlay");
            markerOverlay.Markers.Add(new Marker(0, 0));
            markerOverlay.DragMode = MarkerDragMode.Drag;
            markerOverlay.OnClientMarkerDragged = "onClientMarkerDragged";
            map.CustomOverlays.Add(markerOverlay);

            return View(map);
        }

        [MapActionFilter]
        public void UpdateDragableMarker(Map map, GeoCollection<object> args)
        {
            SimpleMarkerOverlay markerOverlay = map.CustomOverlays.OfType<SimpleMarkerOverlay>().FirstOrDefault();
            if (markerOverlay != null)
            {
                Marker marker = markerOverlay.Markers.FirstOrDefault(m => m.Id.Equals(args["id"]));
                marker.Position = new PointShape(double.Parse(args["lon"].ToString()), double.Parse(args["lat"].ToString()));
            }
        }
    }
}